## file: lcs.py -- AP3 td7 correction
##
## Implements dynamic programming for lcs

import string,random

## print a matrix
def pp_matrix(m):
  print('\n'.join([''.join(['{:12}'.format(item) for item in row]) 
                   for row in m]))
  return None

## format: u,v are strings. dynlcs(u,v) returns the length of a matrix
## with cell (i,j) containing a pair (n,d) where n is the length of a
## longest common subsequence of u[:i] and v[:j] and where d is the
## 'direction' (i.e. north, west or north-west) leading to the result.
def dynlcs(u,v):
  p,q = len(u),len(v)
  a = [[(0,'') for j in range(q+1)] for i in range(p+1)]
  for i in range(1,p+1):
    for j in range(1,q+1):
      (nw,_),(n,_),(w,_) = a[i-1][j-1],a[i-1][j],a[i][j-1]
      if u[i-1]==v[j-1]: nw+=1
      if nw>=n and nw>=w:
        a[i][j] = (nw,'NW')
      else:
        if n>=w: a[i][j] = (n,'N')
        else: a[i][j] = (w,'W')
  return a

## format: u,v are strings. lcs(u,v) returns a pair of lists
## containing the positions of the letters in u and v composing a
## longest common subsequence.
def lcs(u,v):
  p,q = len(u),len(v)
  a = dynlcs(u,v)
  subu,subv = [],[]
  i,j = p,q
  (rem,dir) = a[p][q]
  while rem > 0:
    if dir=='NW':
      if u[i-1]==v[j-1]:
        subu,subv = [i-1]+subu,[j-1]+subv
      i,j = i-1,j-1
    elif dir=='N': i = i-1
    else: j = j-1
    (rem,dir) = a[i][j]
  return (subu,subv)
  
## format: u,v are strings. verifylcs(u,v) returns True if the longest
## common subsequence is correct, False otherwise.
def veriflcs(u,v):
  (subu,subv) = lcs(u,v)
  return ''.join([u[k] for k in subu]) == ''.join([v[k] for k in subv])


## testing -- takes 10000 pairs of words on length 10 each and verify
## lcs for each pair; should return True if everything work.
print reduce(lambda x,y: x and y,[\
  veriflcs(''.join([random.choice(string.letters) for j in range(10)]),\
           ''.join([random.choice(string.letters) for j in range(10)]))\
                                  for i in range(10000)], True)
