import random

## print a matrix
def pp_matrix(m):
  print('\n'.join([''.join(['{:20}'.format(item) for item in row]) 
                   for row in m]))
  return None

## format: p is a list of integers. dynprod(p) returns the matrix
## described in the subject, i.e. in cell (i,j) it contains a pair
## (m,s) with m the minimal number of multiplication necessary to
## compute Ai...Aj and whit s an actual parenthesing realizing this
## minimum.
def dynprod (p):
  n = len(p) - 1
  mat = [[(0,"") for j in range(n)] for i in range(n)]
  for i in range(n): mat[i][i] = (0,"A"+str(i+1))
  for l in range(2,n+1):
    for i in range(n+1-l):
      j,m,s = i+l-1,-1,""
      for k in range(i,j):
        (ikn,iks) = mat[i][k]
        (kjn,kjs) = mat[k+1][j]
        curr = ikn + kjn + p[i-1]*p[k]*p[j]
        if curr < m or m == -1 :
          m = curr
          s = "(" + iks + ")(" + kjs + ")"
      mat[i][j] = (m,s)
  return mat

## format: p is a list of integers. optprod(p) returns the minimal
## number of multiplication necessary to compute A1...An together with
## a matching parenthesing.
def optprod(p): return dynprod(p)[0][-1]

## TEST ##
ntest,length_prod,max_size = 100,10,20
for i in range(ntest):
  print "Test", i, ":",
  print optprod([random.randint(1,max_size) for x in range(length_prod+1)])

print
print "Test subject :",
print optprod([1,1,1,1,4])
